﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.CalcEngine;

namespace _6323_CustomFun
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.fpSpread1.Sheets[0].AutoCalculation = true;
            AbcFunctionInfo abc = new AbcFunctionInfo();

            this.fpSpread1.Sheets[0].AddCustomFunction(abc);

            this.fpSpread1.Sheets[0].SetFormula(5, 0, "ABC(" + this.fpSpread1.Sheets[0].Cells[0, 0].Value.ToString() + ")");
        }

        private void saveXMLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.fpSpread1.Save(System.IO.Path.Combine(Application.StartupPath, "test.xml"), false);
        }

        private void openXMLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.fpSpread1.Open(System.IO.Path.Combine(Application.StartupPath, "test.xml"));
        }

        private void recToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.fpSpread1.Sheets[0].Recalculate();
            this.fpSpread1.Sheets[0].RecalculateAll();
            //this.fpSpread1.Sheets[0].SetFormula(2, 0, "CUBE(" + this.fpSpread1.Sheets[0].Cells[0, 0].Value.ToString() + ")");

        }
    }
    [Serializable]
    public class AbcFunctionInfo : FunctionInfo
    {
        private int count = 0;
        public override string Name
        {
            get { return "ABC"; }
        }
        public override int MinArgs
        {
            get { return 0; }
        }
        public override int MaxArgs
        {
            get { return 100; }
        }
        public override bool IsVolatile()
        {
            return true;
        }
        public override object Evaluate(object[] args)
        {
            count = count + 1;
            return count;
        }
    }

}
